/**
 * Copyright (c) 2004 Logos GmbH Rostock (www.logos-ib.de).
 * All rights reserved.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL  LOGOS GMBH  OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package de.bsvrz.dua.bastband.bastband.dvs.funclib.objectwrapper;

/**
 * History:
 * 2007-07-09 [KS] Zugriff auf zentrale statische Konfigurationskonstanten in
 *                 de.logosib.dvs.funclib.constants.ConfigurationConstants.*
 *
 * $Log: DEKanal.java,v $
 * Revision 1.7  2007/08/22 07:48:43  Trier
 * <Kein Kommentar eingegeben>
 *
 * Revision 1.6  2007/08/08 11:25:54  Trier
 * <Kein Kommentar eingegeben>
 *
 * Revision 1.5  2007/08/06 11:52:16  Trier
 * Änderung Log-System
 *
 * Revision 1.4  2007/08/02 11:31:35  Trier
 * <Kein Kommentar eingegeben>
 *
 * Revision 1.3  2007/07/25 13:02:07  Trier
 * <Kein Kommentar eingegeben>
 *
 * Revision 1.2  2007/07/09 14:21:39  Strey
 * Zugriff auf zentrale statische Konfigurationskonstanten in de.logosib.dvs.funclib.constants.ConfigurationConstants.*
 *
 * Revision 1.1  2007/07/04 11:43:40  Trier
 * Neuordnung
 *
 * Revision 1.1.1.1  2007/06/20 09:56:26  Trier
 * dvs alles
 *
 * Revision 1.15  2007/06/14 13:57:47  Trier
 * <Kein Kommentar eingegeben>
 *
 * Revision 1.14  2006/04/28 05:48:49  Trier
 * Generics 1.5 verwendet
 *
 * Revision 1.13  2005/11/09 14:23:04  Trier
 * <Kein Kommentar eingegeben>
 *
 * Revision 1.12  2005/10/24 07:38:27  Trier
 * <Kein Kommentar eingegeben>
 *
 * Revision 1.11  2005/10/05 11:27:55  Trier
 * <Kein Kommentar eingegeben>
 *
 * Revision 1.10  2005/09/16 08:18:14  Trier
 * <Kein Kommentar eingegeben>
 *
 * Revision 1.9  2005/09/09 07:37:28  Trier
 * <Kein Kommentar eingegeben>
 *
 * Revision 1.8  2005/09/06 13:59:17  Trier
 * <Kein Kommentar eingegeben>
 *
 * Revision 1.7  2005/04/21 09:15:34  Trier
 * <Kein Kommentar eingegeben>
 *
 * Revision 1.6  2005/03/16 08:11:02  Trier
 * <Kein Kommentar eingegeben>
 *
 * Revision 1.5  2005/03/09 13:54:10  Trier
 * <Kein Kommentar eingegeben>
 *
 * Revision 1.4  2005/02/18 10:08:48  Trier
 * <Kein Kommentar eingegeben>
 *
 * Revision 1.3  2005/01/31 15:24:48  Trier
 * <Kein Kommentar eingegeben>
 *
 * Revision 1.2  2005/01/25 09:43:11  Trier
 * <Kein Kommentar eingegeben>
 *
 * Revision 1.1  2005/01/21 13:25:54  Trier
 * <Kein Kommentar eingegeben>
 *
 */

import java.util.HashMap;
import java.util.List;
import java.util.TreeSet;
import java.util.WeakHashMap;

import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.DataDescription;
import de.bsvrz.dav.daf.main.config.Aspect;
import de.bsvrz.dav.daf.main.config.AttributeGroup;
import de.bsvrz.dav.daf.main.config.ConfigurationObject;
import de.bsvrz.dav.daf.main.config.ConfigurationObjectType;
import de.bsvrz.dav.daf.main.config.DataModel;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.dua.bastband.bastband.dvs.funclib.DataModellMismatchException;
import de.bsvrz.dua.bastband.bastband.dvs.funclib.DataModellObjectNotFoundException;
import de.bsvrz.dua.bastband.bastband.dvs.funclib.LogosClientDavConnection;
import de.bsvrz.dua.bastband.bastband.funclib.logger.Logger;

/**
 * kapselt den DatenModellTyp de (Daten-End-Ger&auml;t).
 *
 * <pre>
 * deLve     Datenendgerätekanal der Funktionsgruppe 1, LokaleVerkehrsErfassung.
 * deAxl     Datenendgerätekanal der Funktionsgruppe 2, AchsLastdaten.
 * deUfd     Datenendgerätekanal der Funktionsgruppe 3, UmFeldDaten.
 * deWzg     Datenendgerätekanal der Funktionsgruppe 4, WechselZeichenGeber.
 * deVlt     Datenendgerätekanal der Funktionsgruppe 6, Netze der VerkehrLeitTechnik.
 * deSys     Datenendgerätekanal der Funktionsgruppe 254, System.
 * </pre>
 *
 */
public abstract class DEKanal extends ConfigurationObjectWrapper {

	private static final Logger LOGGER = de.bsvrz.dua.bastband.bastband.funclib.logger.LoggerFactory.getLoggerFactory()
			.getLogger();

	private static final WeakHashMap<String, DEKanal> CACHE = new WeakHashMap<>();
	static HashMap<String, DEKanal.Lve> deLveCache = new HashMap<>();

	private static DataDescription __DataDescrFehlerMeldung;

	private static ConfigurationObjectType __ConfigurationObjectTypeDeLve;
	private static ConfigurationObjectType __ConfigurationObjectTypeDeAxl;
	private static ConfigurationObjectType __ConfigurationObjectTypeDeUfd;
	private static ConfigurationObjectType __ConfigurationObjectTypeDeWzg;
	private static ConfigurationObjectType __ConfigurationObjectTypeDeVlt;
	private static ConfigurationObjectType __ConfigurationObjectTypeDeSys;

	private static AttributeGroup __AtgDE;

	private String _Bezeichnung;
	boolean _Cluster;
	int _EAKanal;
	/**
	 * DE-Nummer des Datenendger&auml;tes
	 */
	int _DEKanal;
	String _UmsetzungsModul;

	private EAK _Eak;

	/**
	 * setzt den EAK, an den der DEKanal angeschlossen ist.
	 *
	 * @param eak
	 *            EAK, an den der DEKanal angeschlossen ist.
	 */
	public void setEAK(final EAK eak) {
		_Eak = eak;
	}

	/**
	 * gibt den EAK zur&uuml;ck, an den der DEKanal angeschlossen ist (L&auml;dt
	 * automatisch die TLS-Struktur durch
	 * {@link de.bsvrz.dua.bastband.bastband.dvs.funclib.objectwrapper.KRI#getAll()}
	 * ).
	 *
	 * @return EAK
	 */
	public EAK getEAK() {
		if (_Eak == null) {
			try {
				KRI.getAll();
			} catch (final Exception ex) {
				ex.printStackTrace();
			}
		}
		return _Eak;
	}

	/**
	 * gibt das zust&auml;ndige UmsetzungsModul zur&uuml;ck.
	 *
	 * @return String
	 */
	public String getUmsetzungsModul() {
		return _UmsetzungsModul;
	}

	/**
	 * gibt die DataDescription zur&uuml;ck, die f&uuml;r die
	 * "Erg&auml;nzende DE-Fehlermeldung" zust&auml;ndig ist.
	 *
	 * @return String
	 */
	public abstract DataDescription getDataDescrErgaenzendeFehlerMeldung();

	/**
	 * gibt die DataDescription zur&uuml;ck, die f&uuml;r die
	 * "Negative Quittung" zust&auml;ndig ist.
	 *
	 * @return String
	 */
	public abstract DataDescription getDataDescrNegativeQuittung();

	/**
	 * gibt die DataDescription zur&uuml;ck, die f&uuml;r die
	 * "Negative Quittung" zust&auml;ndig ist.
	 *
	 * @return String
	 */
	public DataDescription getDataDescrTLSFehlerMeldung() {
		if (DEKanal.__DataDescrFehlerMeldung == null) {
			final DataModel model = LogosClientDavConnection.getInstance().getDataModel();
			final AttributeGroup atg = model.getAttributeGroup("atg.tlsGloDeFehler");
			final Aspect asp = model.getAspect("asp.tlsAntwort");
			DEKanal.__DataDescrFehlerMeldung = new DataDescription(atg, asp, (short) 0);
		}
		return DEKanal.__DataDescrFehlerMeldung;
	}

	/**
	 * gibt die Bezeichnung zur&uuml;ck.
	 *
	 * @return String
	 */
	public String getBezeichnung() {
		return _Bezeichnung;
	}

	/**
	 * gibt an, ob es sich bei der DE um einen Clusterkanal handelt.
	 *
	 * @return boolean
	 */
	public boolean isCluster() {
		return _Cluster;
	}

	/**
	 * gibt an, ob es sich bei der DE um einen SteuerKanal (deSys 254) handelt.
	 *
	 * @return boolean
	 */
	public boolean isSteuerKanal() {
		return (this instanceof DEKanal.Sys);
	}

	/**
	 * gibt die DE-Nummer des Datenendgerätes zur&uuml;ck.
	 *
	 * @return byte
	 */
	public int getDEKanal() {
		return _DEKanal;
	}

	/**
	 * gibt die zugeordnete EA-Kanalnummer des DE am zugehörigen EAK
	 * zur&uuml;ck.
	 *
	 * @return byte
	 */
	public int getEAKanal() {
		return _EAKanal;
	}

	/**
	 * erzeugt das WrapperObject f&uuml;r das Object mit der angegebenen Pid.
	 *
	 * @see ConfigurationObjectWrapper#ConfigurationObjectWrapper(String pid)
	 *
	 * @param pid
	 *            String
	 * @throws DataModellMismatchException
	 *             ungültiges Datenmodell
	 * @throws DataModellObjectNotFoundException
	 *             ungültiges Datenmodell
	 */
	private DEKanal(final String pid) throws DataModellMismatchException, DataModellObjectNotFoundException {
		super(pid);
	}

	/**
	 * erzeugt das WrapperObject f&uuml;r das angegebene Object.
	 *
	 * @param confObj
	 *            ConfigurationObject
	 * @throws DataModellMismatchException
	 *             ungültiges Datenmodell
	 */
	private DEKanal(final ConfigurationObject confObj) throws DataModellMismatchException {
		super(confObj);
	}

	@Override
	protected void initData(final ConfigurationObject deKanal) throws DataModellMismatchException {

		final Data oData = deKanal.getConfigurationData(DEKanal.__AtgDE);
		if (oData != null) {
			_Bezeichnung = oData.getTextValue("Bezeichnung").getText();
			// <zustand name="Ja" wert="1"/><zustand name="Nein" wert="0"/>
			_Cluster = (oData.getUnscaledValue("Cluster").intValue() == 1) ? true : false;
			_EAKanal = oData.getUnscaledValue("EAKanal").intValue();
			_DEKanal = oData.getUnscaledValue("DEKanal").intValue();
			_UmsetzungsModul = oData.getTextValue("UmsetzungsModul").getText();
		}
		DEKanal.CACHE.put(this.getPID(), this);
	}

	static public DEKanal getInstance(final ConfigurationObject confObj) throws DataModellMismatchException {

		if (DEKanal.__AtgDE == null) {
			final DataModel model = LogosClientDavConnection.getInstance().getDataModel();
			DEKanal.__AtgDE = model.getAttributeGroup("atg.de");
			DEKanal.__ConfigurationObjectTypeDeLve = (ConfigurationObjectType) model.getType("typ.deLve");
			DEKanal.__ConfigurationObjectTypeDeAxl = (ConfigurationObjectType) model.getType("typ.deAxl");
			DEKanal.__ConfigurationObjectTypeDeUfd = (ConfigurationObjectType) model.getType("typ.deUfd");
			DEKanal.__ConfigurationObjectTypeDeWzg = (ConfigurationObjectType) model.getType("typ.deWzg");
			DEKanal.__ConfigurationObjectTypeDeVlt = (ConfigurationObjectType) model.getType("typ.deVlt");
			DEKanal.__ConfigurationObjectTypeDeSys = (ConfigurationObjectType) model.getType("typ.deSys");
			final ConfigurationObjectType configurationObjectTypeDe = (ConfigurationObjectType) model.getType("typ.de");

			final List<SystemObject> list = configurationObjectTypeDe.getObjects();
			model.getConfigurationData(list, DEKanal.__AtgDE);
		}

		final Object o = DEKanal.CACHE.get(confObj.getPid());
		if (o != null) {
			return (DEKanal) o;
		}

		if (confObj.isOfType(DEKanal.__ConfigurationObjectTypeDeLve)) {
			return new Lve(confObj);
		}
		if (confObj.isOfType(DEKanal.__ConfigurationObjectTypeDeSys)) {
			return new Sys(confObj);
		}
		if (confObj.isOfType(DEKanal.__ConfigurationObjectTypeDeAxl)) {
			return new Axl(confObj);
		}
		if (confObj.isOfType(DEKanal.__ConfigurationObjectTypeDeUfd)) {
			return new Ufd(confObj);
		}
		if (confObj.isOfType(DEKanal.__ConfigurationObjectTypeDeWzg)) {
			return new Wzg(confObj);
		}
		if (confObj.isOfType(DEKanal.__ConfigurationObjectTypeDeVlt)) {
			return new Vlt(confObj);
		}

		// if (confObj.isOfType(__ConfigurationObjectTypeDeUfd)) {
		// return new Ufd(confObj);
		// }
		// if (confObj.isOfType(__ConfigurationObjectTypeDeSys)) {
		// return new Sys(confObj);
		// }
		// if (confObj.isOfType(__ConfigurationObjectTypeDeLve)) {
		// return new Lve(confObj);
		// }
		// if (confObj.isOfType(__ConfigurationObjectTypeDeAxl)) {
		// return new Axl(confObj);
		// }
		// if (confObj.isOfType(__ConfigurationObjectTypeDeWzg)) {
		// return new Wzg(confObj);
		// }
		// if (confObj.isOfType(__ConfigurationObjectTypeDeVlt)) {
		// return new Vlt(confObj);
		// }

		return null;
	}

	static public DEKanal getInstance(final String pid) throws DataModellMismatchException {
		Object o = DEKanal.CACHE.get(pid);
		if (o != null) {
			return (DEKanal) o;
		}
		o = LogosClientDavConnection.getInstance().getDataModel().getObject(pid);
		if ((o != null) && (o instanceof ConfigurationObject)) {
			return DEKanal.getInstance((ConfigurationObject) o);
		}
		return null;
	}

	/**
	 * kapselt einen DEKanal f&uuml;r die lokale Verkehrsdatenerfassung (LVE,
	 * FG1).
	 */
	public static class Lve extends DEKanal implements FahrstreifenQuelle {

		private static DataDescription __DataDescrNegativeQuittung;
		private static DataDescription __DataDescrErgaenzendeFehlerMeldung;
		private static ConfigurationObjectType __ConfigurationObjectType;

		private Fahrstreifen _Fahrstreifen;

		protected Lve(final String pid) throws DataModellMismatchException, DataModellObjectNotFoundException {
			super(pid);
			DEKanal.deLveCache.put(this.getPID(), this);
		}

		protected Lve(final ConfigurationObject confObj) throws DataModellMismatchException {
			super(confObj);
			DEKanal.deLveCache.put(this.getPID(), this);
		}

		public void setFahrstreifen(final Fahrstreifen fs) {
			_Fahrstreifen = fs;
		}

		public Fahrstreifen getFahrstreifen() {
			if (_Fahrstreifen == null) {
				try {
					LangZeitZaehlStelle.getAll();
				} catch (final DataModellMismatchException ex) {
					ex.printStackTrace();
				} catch (final Exception ex) {
					ex.printStackTrace();
				}
			}
			return _Fahrstreifen;
		}

		/*
		 * public String getTreeString() { if (this.getDEKanal()==255) { return
		 * ("DE FG 1 - Sammelkanal 255" + " (Pid: " + getPID() + ")"); } else {
		 * return ("DE FG 1 - " + getBezeichnung() + " (Pid: " + getPID() +
		 * ")"); } }
		 */
		@Override
		public String getTreeString() {
			if (this.getDEKanal() == 255) {
				return ("DE FG 1 - Sammelkanal 255" + " (Pid: " + getPID() + ")");
			}
			final Fahrstreifen fs = getFahrstreifen();
			if (fs != null) {
				final MessQuerschnitt mq = fs.getMessQuerschnitt();
				if ((mq != null) && (mq.getAuswerteQuerschnitt() != null)) {
					return ("DE FG 1 - " + mq.getAuswerteQuerschnitt().getTreeString() + "-" + fs.getTreeString()
							+ " (Pid: " + getPID() + ")");
				}
				return ("DE FG 1 - " + fs.getTreeString() + " (Pid: " + getPID() + ")");
			}
			return ("DE FG 1 - " + getBezeichnung() + " (Pid: " + getPID() + ")");
		}

		@Override
		ConfigurationObjectType getType() {
			return DEKanal.__ConfigurationObjectTypeDeLve;
		}

		@Override
		public DataDescription getDataDescrErgaenzendeFehlerMeldung() {
			if (Lve.__DataDescrErgaenzendeFehlerMeldung == null) {
				final DataModel model = LogosClientDavConnection.getInstance().getDataModel();
				final AttributeGroup atg = model.getAttributeGroup("atg.tlsLveErgänzendeDeFehlerMeldung");
				final Aspect asp = model.getAspect("asp.tlsAntwort");
				Lve.__DataDescrErgaenzendeFehlerMeldung = new DataDescription(atg, asp, (short) 0);
			}
			return Lve.__DataDescrErgaenzendeFehlerMeldung;
		}

		@Override
		public DataDescription getDataDescrNegativeQuittung() {
			if (Lve.__DataDescrNegativeQuittung == null) {
				final DataModel model = LogosClientDavConnection.getInstance().getDataModel();
				final AttributeGroup atg = model.getAttributeGroup("atg.tlsLveNegativeQuittung");
				final Aspect asp = model.getAspect("asp.tlsAntwort");
				Lve.__DataDescrNegativeQuittung = new DataDescription(atg, asp, (short) 0);
			}
			return Lve.__DataDescrNegativeQuittung;
		}

	}

	/**
	 * kapselt einen DEKanal f&uuml;r die Erfassung von Achslastdaten (FG2).
	 */
	public static class Axl extends DEKanal implements FahrstreifenQuelle {

		private static DataDescription __DataDescrNegativeQuittung;
		private static DataDescription __DataDescrErgaenzendeFehlerMeldung;

		private Fahrstreifen _Fahrstreifen;

		protected Axl(final String pid) throws DataModellMismatchException, DataModellObjectNotFoundException {
			super(pid);
		}

		protected Axl(final ConfigurationObject confObj) throws DataModellMismatchException {
			super(confObj);
		}

		@Override
		public String getTreeString() {
			if (this.getDEKanal() == 255) {
				return ("DE FG 2 - Sammelkanal 255" + " Pid: " + getPID());
			}
			return ("DE FG 2 " + this.getBezeichnung() + " Pid: " + getPID());
		}

		@Override
		ConfigurationObjectType getType() {
			return DEKanal.__ConfigurationObjectTypeDeAxl;
		}

		public void setFahrstreifen(final Fahrstreifen fs) {
			_Fahrstreifen = fs;
		}

		@Override
		public DataDescription getDataDescrErgaenzendeFehlerMeldung() {
			if (Axl.__DataDescrErgaenzendeFehlerMeldung == null) {
				final DataModel model = LogosClientDavConnection.getInstance().getDataModel();
				final AttributeGroup atg = model.getAttributeGroup("atg.tlsAxlErgänzendeDeFehlerMeldung");
				final Aspect asp = model.getAspect("asp.tlsAntwort");
				Axl.__DataDescrErgaenzendeFehlerMeldung = new DataDescription(atg, asp, (short) 0);
			}
			return Axl.__DataDescrErgaenzendeFehlerMeldung;
		}

		@Override
		public DataDescription getDataDescrNegativeQuittung() {
			if (Axl.__DataDescrNegativeQuittung == null) {
				final DataModel model = LogosClientDavConnection.getInstance().getDataModel();
				final AttributeGroup atg = model.getAttributeGroup("atg.tlsAxlNegativeQuittung");
				final Aspect asp = model.getAspect("asp.tlsAntwort");
				Axl.__DataDescrNegativeQuittung = new DataDescription(atg, asp, (short) 0);
			}
			return Axl.__DataDescrNegativeQuittung;
		}

	}

	/**
	 * kapselt einen DEKanal f&uuml;r die Erfassung von Umfelddaten (FG3).
	 */
	public static class Ufd extends DEKanal {

		private static DataDescription dataDescrNegativeQuittung;
		private static DataDescription dataDescrErgaenzendeFehlerMeldung;
		private static ConfigurationObjectType configurationObjectType;

		public static TreeSet<String> testTreeSet = new TreeSet<>();

		FG03Type type;
		int fbNr = 0;

		protected Ufd(final String pid) throws DataModellMismatchException, DataModellObjectNotFoundException {
			super(pid);
		}

		protected Ufd(final ConfigurationObject confObj) throws DataModellMismatchException {
			super(confObj);
		}

		@Override
		protected void initData(final ConfigurationObject deKanal) throws DataModellMismatchException {
			super.initData(deKanal);
			type = FG03Type.getInstance(_UmsetzungsModul);
			if ((type == null) && (getEAKanal() != 255)) {
				DEKanal.LOGGER.debug(
						_ConfigurationObject.getPid() + " Umsetzungsmodul: " + _UmsetzungsModul + " - kein FG03Type");
				Ufd.testTreeSet.add(_UmsetzungsModul);
			}
		}

		public int getFBNr() {
			if (type.isFahrstreifenSensor()) {
				return fbNr;
			}
			return -1;
		}

		public static int getFBNr(final String pid) {
			int i = 3;
			while (pid.charAt(i) != '.') {
				i++;
			}
			final char ch = pid.charAt(i + 1);
			if (ch == '3') {
				return 2;
			}
			if (ch == '2') {
				return 1;
			}
			return 0;
		}

		@Override
		public String getTreeString() {
			if (this.getDEKanal() == 255) {
				return ("DE FG 3 - Sammelkanal 255" + " Pid: " + getPID());
			}
			return ("DE FG 3 " + this.getBezeichnung() + " Pid: " + getPID());
		}

		public FG03Type getFG03Type() {
			return type;
		}

		@Override
		ConfigurationObjectType getType() {
			return DEKanal.__ConfigurationObjectTypeDeUfd;
		}

		@Override
		public DataDescription getDataDescrErgaenzendeFehlerMeldung() {
			if (Ufd.dataDescrErgaenzendeFehlerMeldung == null) {
				final DataModel model = LogosClientDavConnection.getInstance().getDataModel();
				final AttributeGroup atg = model.getAttributeGroup("atg.tlsUfdErgänzendeDeFehlerMeldung");
				final Aspect asp = model.getAspect("asp.tlsAntwort");
				Ufd.dataDescrErgaenzendeFehlerMeldung = new DataDescription(atg, asp, (short) 0);
			}
			return Ufd.dataDescrErgaenzendeFehlerMeldung;
		}

		@Override
		public DataDescription getDataDescrNegativeQuittung() {
			if (Ufd.dataDescrNegativeQuittung == null) {
				final DataModel model = LogosClientDavConnection.getInstance().getDataModel();
				final AttributeGroup atg = model.getAttributeGroup("atg.tlsUfdNegativeQuittung");
				final Aspect asp = model.getAspect("asp.tlsAntwort");
				Ufd.dataDescrNegativeQuittung = new DataDescription(atg, asp, (short) 0);
			}
			return Ufd.dataDescrNegativeQuittung;
		}

	}

	/**
	 * kapselt einen DEKanal f&uuml;r die WechselZeichenGeber (FG4).
	 */
	public static class Wzg extends DEKanal {

		private static DataDescription __DataDescrNegativeQuittung;
		private static DataDescription __DataDescrErgaenzendeFehlerMeldung;
		private static ConfigurationObjectType __ConfigurationObjectType;

		protected Wzg(final String pid) throws DataModellMismatchException, DataModellObjectNotFoundException {
			super(pid);
		}

		protected Wzg(final ConfigurationObject confObj) throws DataModellMismatchException {
			super(confObj);
		}

		@Override
		public String getTreeString() {
			if (this.getDEKanal() == 255) {
				return ("DE FG 4 - Sammelkanal 255" + " Pid: " + getPID());
			}
			return ("DE FG 4 " + this.getBezeichnung() + " Pid: " + getPID());
		}

		@Override
		ConfigurationObjectType getType() {
			return DEKanal.__ConfigurationObjectTypeDeWzg;
		}

		@Override
		public DataDescription getDataDescrErgaenzendeFehlerMeldung() {
			if (Wzg.__DataDescrErgaenzendeFehlerMeldung == null) {
				final DataModel model = LogosClientDavConnection.getInstance().getDataModel();
				final AttributeGroup atg = model.getAttributeGroup("atg.tlsWzgErgänzendeDeFehlerMeldung");
				final Aspect asp = model.getAspect("asp.tlsAntwort");
				Wzg.__DataDescrErgaenzendeFehlerMeldung = new DataDescription(atg, asp, (short) 0);
			}
			return Wzg.__DataDescrErgaenzendeFehlerMeldung;
		}

		@Override
		public DataDescription getDataDescrNegativeQuittung() {
			if (Wzg.__DataDescrNegativeQuittung == null) {
				final DataModel model = LogosClientDavConnection.getInstance().getDataModel();
				final AttributeGroup atg = model.getAttributeGroup("atg.tlsWzgNegativeQuittung");
				final Aspect asp = model.getAspect("asp.tlsAntwort");
				Wzg.__DataDescrNegativeQuittung = new DataDescription(atg, asp, (short) 0);
			}
			return Wzg.__DataDescrNegativeQuittung;
		}
	}

	/**
	 * kapselt einen DEKanal f&uuml;r die VerkehrLeitTechnik (FG6).
	 */
	public static class Vlt extends DEKanal {

		private static DataDescription dataDescrNegativeQuittung;
		private static DataDescription dataDescrErgaenzendeFehlerMeldung;

		private static ConfigurationObjectType configurationObjectType;

		private FG06Type type;

		protected Vlt(final String pid) throws DataModellMismatchException, DataModellObjectNotFoundException {
			super(pid);
		}

		protected Vlt(final ConfigurationObject confObj) throws DataModellMismatchException {
			super(confObj);
			type = FG06Type.getInstance(_UmsetzungsModul);
			if ((type == null) && (getEAKanal() != 255)) {
				DEKanal.LOGGER.info("%s UmsetzungsModul=%s -kein FG06Type", _ConfigurationObject.getPid(),
						_UmsetzungsModul);
			}
		}

		@Override
		public String getTreeString() {
			if (this.getDEKanal() == 255) {
				return ("DE FG 6 - Sammelkanal 255" + " Pid: " + getPID());
			}
			return ("DE FG 6 " + this.getBezeichnung() + " Pid: " + getPID());
		}

		@Override
		ConfigurationObjectType getType() {
			return DEKanal.__ConfigurationObjectTypeDeVlt;
		}

		@Override
		public DataDescription getDataDescrErgaenzendeFehlerMeldung() {
			if (Vlt.dataDescrErgaenzendeFehlerMeldung == null) {
				final DataModel model = LogosClientDavConnection.getInstance().getDataModel();
				final AttributeGroup atg = model.getAttributeGroup("atg.tlsVltErgänzendeDeFehlerMeldung");
				final Aspect asp = model.getAspect("asp.tlsAntwort");
				Vlt.dataDescrErgaenzendeFehlerMeldung = new DataDescription(atg, asp, (short) 0);
			}
			return Vlt.dataDescrErgaenzendeFehlerMeldung;
		}

		@Override
		public DataDescription getDataDescrNegativeQuittung() {
			if (Vlt.dataDescrNegativeQuittung == null) {
				final DataModel model = LogosClientDavConnection.getInstance().getDataModel();
				final AttributeGroup atg = model.getAttributeGroup("atg.tlsVltNegativeQuittung");
				final Aspect asp = model.getAspect("asp.tlsAntwort");
				Vlt.dataDescrNegativeQuittung = new DataDescription(atg, asp, (short) 0);
			}
			return Vlt.dataDescrNegativeQuittung;
		}

		public FG06Type getFG06Type() {
			return type;
		}

	}

	/**
	 * kapselt einen DEKanal f&uuml;r die SystemSteuerung (FG254).
	 */
	public static class Sys extends DEKanal {

		private static DataDescription dataDescrNegativeQuittung;
		private static DataDescription dataDescrErgaenzendeFehlerMeldung;
		private static ConfigurationObjectType configurationObjectType;

		protected Sys(final String pid) throws DataModellMismatchException, DataModellObjectNotFoundException {
			super(pid);
		}

		protected Sys(final ConfigurationObject confObj) throws DataModellMismatchException {
			super(confObj);
		}

		@Override
		public String getTreeString() {
			if (this.getDEKanal() == 255) {
				return ("DE FG 254 - Sammelkanal 255" + " Pid: " + getPID());
			}
			return ("DE FG 254 " + this.getBezeichnung() + " Pid: " + getPID());
		}

		@Override
		ConfigurationObjectType getType() {
			return DEKanal.__ConfigurationObjectTypeDeSys;
		}

		@Override
		public DataDescription getDataDescrErgaenzendeFehlerMeldung() {
			if (Sys.dataDescrErgaenzendeFehlerMeldung == null) {
				final DataModel model = LogosClientDavConnection.getInstance().getDataModel();
				final AttributeGroup atg = model.getAttributeGroup("atg.tlsSysErgänzendeDeFehlerMeldung");
				final Aspect asp = model.getAspect("asp.tlsAntwort");
				Sys.dataDescrErgaenzendeFehlerMeldung = new DataDescription(atg, asp, (short) 0);
			}
			return Sys.dataDescrErgaenzendeFehlerMeldung;
		}

		@Override
		public DataDescription getDataDescrNegativeQuittung() {
			if (Sys.dataDescrNegativeQuittung == null) {
				final DataModel model = LogosClientDavConnection.getInstance().getDataModel();
				final AttributeGroup atg = model.getAttributeGroup("atg.tlsSysNegativeQuittung");
				final Aspect asp = model.getAspect("asp.tlsAntwort");
				Sys.dataDescrNegativeQuittung = new DataDescription(atg, asp, (short) 0);
			}
			return Sys.dataDescrNegativeQuittung;
		}

	}

}
