/**
 * Copyright (c) 2004 Logos GmbH Rostock (www.logos-ib.de).
 * All rights reserved.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL  LOGOS GMBH  OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package de.bsvrz.dua.bastband.bastband.funclib.logger;

/**
 * History:
 *
 * $Log: StandardLoggerFactory.java,v $
 * Revision 1.2  2007/08/06 09:50:19  Trier
 * Änderung Log-System
 *
 * Revision 1.1.1.1  2007/06/14 08:37:53  Trier
 * Allgemeine Funktionsbibliothek
 *
 */

/**
 *
 * LoggerFactory zum Erzeugen von Logger-Objekten der java.util.logging API.
 *
 * @author Ralf Trier
 */
public class StandardLoggerFactory extends
de.bsvrz.dua.bastband.bastband.funclib.logger.LoggerFactory {

	private static boolean _NotInitialized = true;

	private synchronized void init() {
		if (StandardLoggerFactory._NotInitialized) {
			StandardLoggerFactory._NotInitialized = false;
		}
	}

	public StandardLoggerFactory() {
		init();
	}

	@Override
	public de.bsvrz.dua.bastband.bastband.funclib.logger.Logger getLogger() {
		String debugClassName = "Klassenname nicht ermittelbar!";
		final Throwable t = new Throwable();
		if (t.getStackTrace().length > 1) {
			debugClassName = t.getStackTrace()[1].getClassName();
		}
		return de.bsvrz.dua.bastband.bastband.funclib.logger.StandardLogger
				.getStandardLogger(debugClassName);
	}

	@Override
	public de.bsvrz.dua.bastband.bastband.funclib.logger.Logger getLogger(
			final Class<?> c) {
		return de.bsvrz.dua.bastband.bastband.funclib.logger.StandardLogger
				.getStandardLogger(c);
	}

	@Override
	public de.bsvrz.dua.bastband.bastband.funclib.logger.Logger getLogger(
			final String s) {
		return de.bsvrz.dua.bastband.bastband.funclib.logger.StandardLogger
				.getStandardLogger(s);
	}

	@Override
	public void setRootLevel(
			final de.bsvrz.dua.bastband.bastband.funclib.logger.Logger.Level level) {
		java.util.logging.Logger
		.getLogger("")
		.setLevel(
				de.bsvrz.dua.bastband.bastband.funclib.logger.StandardLogger.JLEVEL[level
				                                                                    .ordinal()]);
	}

	@Override
	public Object getRootLogger() {
		return java.util.logging.Logger.getLogger("");
	}

}
